#include <SD.h>
#include <avr/pgmspace.h>

File myFile;
File root;
long fileSize; // File size in byte

bool isHexFile(char* filename) 
{
    int8_t len = strlen(filename);
    bool result;
    if (  strstr(strlwr(filename + (len - 4)), ".hex")
          || strstr(strlwr(filename + (len - 4)), ".HEX")
       ) 
    {
      result = true;
    } 
    else 
    {
      result = false;
    }
}
  
void setup()
{
  Serial.begin(115200);
  Serial.print("Initializing SD card...");
  // On the Ethernet Shield, CS is pin 4. It's set as an output by default.
  // Note that even if it's not used as the CS pin, the hardware SS pin
  // (10 on most Arduino boards, 53 on the Mega) must be left as an output
  // or the SD library functions will not work.
  pinMode(4, OUTPUT);

  if (!SD.begin(4))
  {
    Serial.println("initialization failed!");
    return;
  }
  Serial.println("initialization done.");

  root = SD.open("/");
  printDirectory(root, 0);
}

void loop()
{
}

void printDirectory(File dir, int numTabs)
{
  byte b;
  
  while (true) 
  {
    File entry =  dir.openNextFile();
    if (! entry) 
    {
      // no more files
      break;
    }
    
    if (!entry.isDirectory()) 
    {
      if ( isHexFile(entry.name()))
      {
        Serial.print(entry.name());
        Serial.println("\n");

        fileSize = entry.size();
        Serial.println(fileSize);
        
        for (long i = 0; i < fileSize; i++)
        {
          b = entry.read();
          //imageArray[i] = b;
          //Serial.println(i);
          
          //Serial.print("\n"); 
          //Serial.print(b, HEX);
        }
        break;
      }
    }
    entry.close();
  } // while
}
